<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateSubmissionsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('submissions', function (Blueprint $table) {
            $table->id();
            $table->foreignId('user_id');
            $table->foreign('user_id')
                  ->references('id')->on('users')
                  ->onDelete('cascade');
            $table->mediumText('code');
            $table->integer('time_limit');
            $table->mediumText('stdin');
            $table->mediumText('stderr')->nullable();
            $table->mediumText('stdout')->nullable();
            $table->enum(
                'status',
                [
                    'pending',
                    'judging',
                    'success',
                    'time_limit_exceeded',
                    'runtime_error',
                    'syntax_error',
                ]
            )->default('pending');
            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('submissions');
    }
}
